<template>
  <el-dialog
    v-loading="loading"
    :title="title"
    shi
    :center="true"
    align="left"
    top="18vh"
    width="500px"
    :close-on-click-modal="false"
    :visible.sync="showModelThis"
    element-loading-text="拼命加载中"
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(0, 0, 0, 0.8)"
    @close="showModelThis = false"
  >
    <el-card style="margin: -20px 0 0 0">
      <el-row :gutter="10">
        <el-col :span="24">
          <el-form
            ref="ruleForm"
            :model="ruleForm"
            status-icon
            :rules="rulesThis"
            label-width="80px"
            class="demo-ruleForm"
          >
            <!-- <el-form-item label="业务公司" prop="companyNo">
              <search-work-company
                disabled
                :value="ruleForm.companyNo"
                :placeholder="'业务公司'"
                size="large"
                @searchChange="companyNosearchChange"
              />
            </el-form-item> -->

            <el-form-item label="订单用途" prop="order_use">
              <el-input
                v-model="ruleForm.order_use"
                :disabled="id == '007'"
                placeholder="订单用途"
                maxlength="20"
              />
            </el-form-item>
          </el-form>
        </el-col>

        <el-col :span="24" style="text-align: right">
          <el-button
            v-if="id !== '007'"
            type="primary"
            @click="submitForm"
          >保 存
          </el-button>
          <el-button @click="showModelThis = false">{{
            id == "007" ? "关 闭" : "取 消"
          }}</el-button>
        </el-col>
      </el-row>
    </el-card>
  </el-dialog>
</template>
<script>
import asyncRequest from '@/apis/service/serviceParam/orderuse'
import resToken from '@/mixins/resToken'
import companyHelper from '@/mixins/companyHelper'
import { getUserCompany } from '@/utils/auth'

export default {
  name: 'Orderuse',
  mixins: [resToken, companyHelper],
  props: ['showModel', 'id', 'sitem'],
  data() {
    return {
      loading: false,
      title: '添加订单用途',
      showModelThis: this.showModel,
      select: '1',
      activeOptions: [],
      actionList: [],
      ruleForm: {
        id: '',
        order_use: '',
        // companyNo: '',
        // companyName: '',
        logo_url: ''
      },
      rulesThis: this.rules,
      rules: {
        order_use: [
          { required: true, message: '订单用途不能为空!', trigger: 'blur' }
        ]
        // companyNo: [
        //   { required: true, message: '请选择业务公司!', trigger: 'blur' }
        // ]
      }
    }
  },
  watch: {
    showModel: function(val) {
      this.showModelThis = val
      if (val) {
        this.initForm()
      }
    },
    showModelThis(val) {
      if (!val) {
        this.$emit('cancel')
      }
    }
  },
  methods: {
    async initForm() {
      this.loading = true
      if (this.id === '003') {
        this.title = '添加订单用途'
        this.rulesThis = this.rules
      } else if (this.id === '005') {
        this.title = '修改订单用途'
        this.rulesThis = this.rules
      } else {
        this.title = '订单用途详情'
        this.rulesThis = {}
      }
      await this.resetForm()
      this.loading = false
    },
    async resetForm() {
      // 重置
      await this.$nextTick(() => {
        if (this.$refs.ruleForm) {
          this.$refs.ruleForm.resetFields()
          this.$refs.ruleForm.clearValidate()
          console.log(this.sitem)

          const { id, order_use, companyNo, companyName } = this.sitem
          this.ruleForm = {
            companyName,
            id: id || '',
            companyNo: companyNo || '',
            order_use: order_use || ''
          }

          if (this.id === '003') {
            const company = getUserCompany()
            console.log(company)

            this.ruleForm.companyNo = this.currentCompany
            this.ruleForm.companyName = company ? company.name : ''
          }
        }
      })
    },
    async submitForm() {
      await this.$refs.ruleForm.validate(async(valid) => {
        if (valid) {
          if (this.loading) {
            return
          }

          this.loading = true
          const model = JSON.parse(JSON.stringify(this.ruleForm))
          let res = {}
          if (this.id === '003') {
            delete model['id']
            res = await asyncRequest.add(model)
          } else {
            res = await asyncRequest.update(model)
          }
          this.loading = false
          if (res && res.code === 0) {
            const title = this.id === 'add' ? '添加成功!' : '修改成功!'
            this.$notify.success({
              title,
              message: ''
            })
            this.showModelThis = false
            // 刷新
            this.$emit('refresh')
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout()
          } else {
            this.$message.warning(res.message)
          }
        } else {
          console.log('error submit!!')
          return false
        }
      })
    },
    // 判断图片规格
    beforeAvatarUpload(file) {
      let isJPG = false
      let isLt2M = false
      if (file) {
        if (
          file.type === 'image/jpg' ||
          file.type === 'image/png' ||
          file.type === 'image/jpeg'
        ) {
          isJPG = true
        }
        isLt2M = file.size / 1024 / 1024 < 1
        if (!isJPG) {
          this.$message.error('图片格式不正确！')
        }
        if (!isLt2M) {
          this.$message.error('图片大小不能超过 1MB!')
        }
      }

      return isJPG && isLt2M
    },
    async companyNosearchChange(e) {
      const { code, label } = e
      this.ruleForm.companyNo = code || ''
      this.ruleForm.companyName = label
    },
    // 图片上传失败
    UploadErrorEvent(res) {
      if (res !== 'break') {
        this.$message.error('图片上传失败!')
        this.ruleForm.logo_url = ''
        this.$refs.ruleForm.validateField('logo_url')
      }
    },
    // 图片上传成功
    async UploadSuccessEvent(data) {
      const { url } = data
      if (url === 'noToken') {
        await this.logout()
      } else {
        this.ruleForm.logo_url = url
        this.$message.success('图片上传成功!')
        this.$refs.ruleForm.validateField('logo_url')
      }
    }
  }
}
</script>

   <style lang="scss" scoped>
.orderuse {
}
</style>
